/*
 * Copyright (c) 2004 Ying Ge, Communication Research Center Canada.
 *
 * Copyright (c) 2002, 2003 Maoyu Wang, Communication Research Center Canada.
 *
 * By Ying Ge:
 * 1. Change the OLSR packet format and message processing procedure based 
 *    on the OLSR RFC.
 * 2. Add support of multiple interfaces to OLSR, including MID message 
 *    creating and processing procedure as specified in the OLSR RFC.
 * 3. Add QoS Support to OLSR
 *
 * By Maoyu Wang:
 * 1. Ported OLSR from IPv4 to IPv6.
 * 2. Added the Host and Network Association (HNA) functionality into OLSR.
 * 3. Added the default gateway functionality into OLSR by extending the HNA 
 *    message usage. The default gateway functionality supported the mobility
 *	  by cooperating with Mobile IPv6 for a mobile node as well as supported 
 * 	  Internet access for MANET nodes. 
 *
 * DISTRIBUTED WITH NO WARRANTY, EXPRESS OR IMPLIED.
 * See the GNU Library General Public License (file COPYING in the distribution)
 * for conditions of use and redistribution
 */
 
#include <ctype.h>

char* 
olsr_skip_whitespace(char* p);

void 
olsr_parse(char* p, char ip[][64], int length[], int* pCount);

struct hna_net_addr*
olsr_lookup_hna_info_node(struct hna_message* message,struct hna_net_addr* netaddr);

void
olsr_set_prefix_in_hna_configuration(struct hna_message* message);

int 
olsr_get_hna_configuration(struct hna_message* message);

void
olsr_release_hna_configuration_list(struct hna_message* message);

void
olsr_set_gateway_configuration(struct hna_message* message,olsr_u16_t length);

void
olsr_init_hna_info();
