/*
 * Department of Systems and Computer Engineering
 * Carleton University, CANADA
 * Copyright (c) 2004 Liang Qin, Department of Systems and Computer Engineering,
 * Carleton University
 * 1. Porting CRC's OLSR with QoS support to XORP 1.0, this release enable OLSR
 *    adds and deletes route entries to RIB in XORP, instead of to Linux kernel. 
 *
*/
#include "libxorp/ipnet.hh"
#include "libxorp/service.hh"
#include "xrl/interfaces/rib_xif.hh"


class XrlSender;
class XrlRouter;
class EventLoop;





/**
 * @short Class to send OLSR updates to RIB process.

 */
class XrlRibNotifier : public ServiceBase
{
public:
    /**
     * Constructor.
     */
    XrlRibNotifier();
    ~XrlRibNotifier();

    /**
     * Request RIB instantiates a RIP routing table and once instantiated
     * start passing route updates to RIB.
     */
    bool startup();
//    static XrlRibNotifier* ribNotifier;
    
    bool shutdown();

	bool send_add_route(const in6_rtmsg aRoute, char* theinterface);
	bool send_delete_route(const in6_rtmsg aRoute);

private:
    void add_igp_cb(const XrlError& e, const char* comment);
    void delete_igp_cb(const XrlError& e);

//    bool send_add_route(const in6_rtmsg aRoute);
//    bool send_delete_route(const in6_rtmsg aRoute);
    void send_route_cb(const XrlError& e);

protected:

//    XrlSender& xsender;
    XrlRibV0p1Client aClient;
    EventLoop& eloop;
    string className;
    string instanceName;
};
